import java.util.*;

public class Solution {
    static final Long INF = 1000000000000000000L;

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        Integer n = scanner.nextInt();
        Long h = scanner.nextLong();

        List<Long> x = new ArrayList<>();
        for (int i = 0; i < n; ++i) {
            x.add(scanner.nextLong());
        }

        scanner.close();

        List<List<Long>> dp = new ArrayList<>();
        for (int i = 0; i < n; ++i) {
            dp.add(new ArrayList<>(Collections.nCopies(n + 1, h)));
        }

        for (int k = 2; k <= n; ++k) {
            for (int l = 0; l + k <= n; ++l) {
                int r = l + k;
                Long ans = INF;
                List<Long> dpLeft = dp.get(l);
                for (int m = l + 1; m < r; ++m) {
                    ans = Math.min(ans, dpLeft.get(m) + dp.get(m).get(r));
                }
                Long depth = (x.get(r - 1) - x.get(l) - 1) / 2;
                if (depth < h) {
                    ans += depth - h;
                }
                dpLeft.set(r, ans);
            }
        }

        System.out.println(dp.get(0).get(n));
    }
}
