#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <ctime>
#include <cassert>
#include <complex>
#include <string>
#include <cstring>
#include <chrono>
#include <random>
#include <bitset>
#include <array>
using namespace std;

#ifdef LOCAL
	#define eprintf(...) {fprintf(stderr, __VA_ARGS__);fflush(stderr);}
#else
	#define eprintf(...) 42
#endif

using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;
template<typename T>
using pair2 = pair<T, T>;
using pii = pair<int, int>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll myRand(ll B) {
	return (ull)rng() % B;
}

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second

clock_t startTime;
double getCurrentTime() {
	return (double)(clock() - startTime) / CLOCKS_PER_SEC;
}

const ll INF = (ll)1e15;
const int K = 50;
const int N = 505;
int n;
ll H;
ll a[N];
pii b[K + 1][N];
pii bb[K + 1][N];
ll curScore[K + 1];
int k;
pli c[K + 1][K + 1];
pair<ll, pii> ord[K * K + 3];

bool checkUnique(int v, int m) {
	for (int i = 0; i < v; i++) {
		bool ok = true;
		for (int j = 0; ok && j < m; j++)
			ok &= b[i][j] == b[v][j];
		if (ok) return false;
	}
	return true;
}

int main()
{
	startTime = clock();
//	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);

	scanf("%d%lld", &n, &H);
	for (int i = 0; i < n; i++)
		scanf("%lld", &a[i]);
	for (int i = 0; i < n; i++)
		b[0][i] = mp(i, i);
	k = 1;
	int m = n;
	while(m > 1) {
		for (int t = 0; t < k; t++) {
			for (int i = 0; i < K; i++)
				c[t][i] = mp(-1LL, -1);
			for (int i = 0; i < m - 1; i++) {
				ll w = max(0LL, H + 1 - (a[b[t][i + 1].second] - a[b[t][i].first] + 1) / 2);
				w += curScore[t];
				pli cc = mp(w, i);
				for (int j = 0; j < K; j++)
					if (cc > c[t][j])
						swap(cc, c[t][j]);
			}
		}
		int sz = 0;
		for (int i = 0; i < k; i++)
			for (int j = 0; j < K; j++) if (c[i][j].second != -1)
				ord[sz++] = mp(c[i][j].first, mp(i, c[i][j].second));
		sort(ord, ord + sz);
		reverse(ord, ord + sz);
		for (int i = 0; i < k; i++)
			for (int j = 0; j < m; j++)
				bb[i][j] = b[i][j];
		k = 0;
		for (int i = 0; k < K && i < sz; i++) {
			curScore[k] = ord[i].first;
			int v = ord[i].second.first;
			int p = ord[i].second.second;
			for (int j = 0; j < p; j++)
				b[k][j] = bb[v][j];
			b[k][p] = mp(bb[v][p].first, bb[v][p + 1].second);
			for (int j = p + 2; j < m; j++)
				b[k][j - 1] = bb[v][j];
			if (checkUnique(k, m - 1)) k++;
		}
		m--;
	}
	printf("%lld\n", H * n - curScore[0]);

	return 0;
}
