#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <ctime>
#include <cassert>
#include <complex>
#include <string>
#include <cstring>
#include <chrono>
#include <random>
#include <bitset>
#include <array>
using namespace std;

#ifdef LOCAL
	#define eprintf(...) {fprintf(stderr, __VA_ARGS__);fflush(stderr);}
#else
	#define eprintf(...) 42
#endif

using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;
template<typename T>
using pair2 = pair<T, T>;
using pii = pair<int, int>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll myRand(ll B) {
	return (ull)rng() % B;
}

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second

clock_t startTime;
double getCurrentTime() {
	return (double)(clock() - startTime) / CLOCKS_PER_SEC;
}

const ll INF = (ll)1e15;
const int N = 505;
int n;
ll H;
ll a[N];
pii b[N];

int main()
{
	startTime = clock();
//	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);

	scanf("%d%lld", &n, &H);
	for (int i = 0; i < n; i++)
		scanf("%lld", &a[i]);
	ll ans = H * n;
	for (int i = 0; i < n; i++)
		b[i] = mp(i, i);
	int m = n;
	while(m > 1) {
		int bst = -1;
		ll val = -1;
		for (int i = 0; i < m - 1; i++) {
			ll w = max(0LL, H + 1 - (a[b[i + 1].second] - a[b[i].first] + 1) / 2);
			if (w > val) {
				val = w;
				bst = i;
			}
		}
		ans -= val;
		b[bst].second = b[bst + 1].second;
		for (int i = bst + 1; i < m - 1; i++)
			b[i] = b[i + 1];
		m--;
	}
	printf("%lld\n", ans);

	return 0;
}
